--[[    
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation, either version 3 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with this program.  If not, see <http://www.gnu.org/licenses/>.

;*
;* GBHW.INC - Gameboy Hardware definitions
;*
]]--

Text = {}

local function TrySDL(func, ...)
local t = { func(...) }
if not t[1] then
error(t[#t])
end
return table.unpack(t)
end

function Text.PrintText(Renderer, String, x, y, w, h)
  local Rect = {}
  
  StringLength = string.len(String)
  
  local i
  
  for i = 1, StringLength do
	Text.PutChar(Renderer, string.sub(String, i, i), x, y, w, h)
	x = x + w
  end
  
end

function Text.PutChar(Renderer, Char, x, y, w, h)	--Ill Add things like lower case letters later...
  local Image = require "SDL.image"
  local Rect = {}

  Rect.x = x
  Rect.y = y
  Rect.w = w
  Rect.h = h
  
  Char = string.upper(Char)
  
  if string.len(Char) > 1 then
  print("Text.PutChar Error: More than one character has been passed.")
  return
  end

  if Char == "A" then
	Renderer:copy(TrySDL(Renderer.createTextureFromSurface, Renderer, TrySDL(Image.load, "./Fonts/A")), nil, Rect)
  elseif Char == "B" then
	Renderer:copy(TrySDL(Renderer.createTextureFromSurface, Renderer, TrySDL(Image.load, "./Fonts/B")), nil, Rect)
  elseif Char == "C" then
  	Renderer:copy(TrySDL(Renderer.createTextureFromSurface, Renderer, TrySDL(Image.load, "./Fonts/C")), nil, Rect)
  elseif Char == "D" then
	Renderer:copy(TrySDL(Renderer.createTextureFromSurface, Renderer, TrySDL(Image.load, "./Fonts/D")), nil, Rect)
  elseif Char == "E" then
	Renderer:copy(TrySDL(Renderer.createTextureFromSurface, Renderer, TrySDL(Image.load, "./Fonts/E")), nil, Rect)
  elseif Char == "F" then
	Renderer:copy(TrySDL(Renderer.createTextureFromSurface, Renderer, TrySDL(Image.load, "./Fonts/F")), nil, Rect)
  elseif Char == "G" then
	Renderer:copy(TrySDL(Renderer.createTextureFromSurface, Renderer, TrySDL(Image.load, "./Fonts/G")), nil, Rect)
  elseif Char == "H" then
	Renderer:copy(TrySDL(Renderer.createTextureFromSurface, Renderer, TrySDL(Image.load, "./Fonts/H")), nil, Rect)
  elseif Char == "I" then
	Renderer:copy(TrySDL(Renderer.createTextureFromSurface, Renderer, TrySDL(Image.load, "./Fonts/I")), nil, Rect)
  elseif Char == "J" then
	Renderer:copy(TrySDL(Renderer.createTextureFromSurface, Renderer, TrySDL(Image.load, "./Fonts/J")), nil, Rect)
  elseif Char == "K" then
	Renderer:copy(TrySDL(Renderer.createTextureFromSurface, Renderer, TrySDL(Image.load, "./Fonts/K")), nil, Rect)
  elseif Char == "L" then
	Renderer:copy(TrySDL(Renderer.createTextureFromSurface, Renderer, TrySDL(Image.load, "./Fonts/L")), nil, Rect)
  elseif Char == "M" then
	Renderer:copy(TrySDL(Renderer.createTextureFromSurface, Renderer, TrySDL(Image.load, "./Fonts/M")), nil, Rect)
  elseif Char == "N" then
	Renderer:copy(TrySDL(Renderer.createTextureFromSurface, Renderer, TrySDL(Image.load, "./Fonts/N")), nil, Rect)
  elseif Char == "O" then
	Renderer:copy(TrySDL(Renderer.createTextureFromSurface, Renderer, TrySDL(Image.load, "./Fonts/O")), nil, Rect)
  elseif Char == "P" then
	Renderer:copy(TrySDL(Renderer.createTextureFromSurface, Renderer, TrySDL(Image.load, "./Fonts/P")), nil, Rect)
  elseif Char == "Q" then
	Renderer:copy(TrySDL(Renderer.createTextureFromSurface, Renderer, TrySDL(Image.load, "./Fonts/Q")), nil, Rect)
  elseif Char == "R" then
	Renderer:copy(TrySDL(Renderer.createTextureFromSurface, Renderer, TrySDL(Image.load, "./Fonts/R")), nil, Rect)
  elseif Char == "S" then
	Renderer:copy(TrySDL(Renderer.createTextureFromSurface, Renderer, TrySDL(Image.load, "./Fonts/S")), nil, Rect)
  elseif Char == "T" then
	Renderer:copy(TrySDL(Renderer.createTextureFromSurface, Renderer, TrySDL(Image.load, "./Fonts/T")), nil, Rect)
  elseif Char == "U" then
	Renderer:copy(TrySDL(Renderer.createTextureFromSurface, Renderer, TrySDL(Image.load, "./Fonts/U")), nil, Rect)
  elseif Char == "V" then
	Renderer:copy(TrySDL(Renderer.createTextureFromSurface, Renderer, TrySDL(Image.load, "./Fonts/V")), nil, Rect)
  elseif Char == "W" then
	Renderer:copy(TrySDL(Renderer.createTextureFromSurface, Renderer, TrySDL(Image.load, "./Fonts/W")), nil, Rect)
  elseif Char == "X" then
	Renderer:copy(TrySDL(Renderer.createTextureFromSurface, Renderer, TrySDL(Image.load, "./Fonts/X")), nil, Rect)
  elseif Char == "Y" then
	Renderer:copy(TrySDL(Renderer.createTextureFromSurface, Renderer, TrySDL(Image.load, "./Fonts/Y")), nil, Rect)
  elseif Char == "Z" then
	Renderer:copy(TrySDL(Renderer.createTextureFromSurface, Renderer, TrySDL(Image.load, "./Fonts/Z")), nil, Rect)
  elseif Char == "0" then
	Renderer:copy(TrySDL(Renderer.createTextureFromSurface, Renderer, TrySDL(Image.load, "./Fonts/0")), nil, Rect)
  elseif Char == "1" then
	Renderer:copy(TrySDL(Renderer.createTextureFromSurface, Renderer, TrySDL(Image.load, "./Fonts/1")), nil, Rect)
  elseif Char == "2" then
	Renderer:copy(TrySDL(Renderer.createTextureFromSurface, Renderer, TrySDL(Image.load, "./Fonts/2")), nil, Rect)
  elseif Char == "3" then
	Renderer:copy(TrySDL(Renderer.createTextureFromSurface, Renderer, TrySDL(Image.load, "./Fonts/3")), nil, Rect)
  elseif Char == "4" then
	Renderer:copy(TrySDL(Renderer.createTextureFromSurface, Renderer, TrySDL(Image.load, "./Fonts/4")), nil, Rect)
  elseif Char == "5" then
	Renderer:copy(TrySDL(Renderer.createTextureFromSurface, Renderer, TrySDL(Image.load, "./Fonts/5")), nil, Rect)
  elseif Char == "6" then
	Renderer:copy(TrySDL(Renderer.createTextureFromSurface, Renderer, TrySDL(Image.load, "./Fonts/6")), nil, Rect)
  elseif Char == "7" then
	Renderer:copy(TrySDL(Renderer.createTextureFromSurface, Renderer, TrySDL(Image.load, "./Fonts/7")), nil, Rect)
  elseif Char == "8" then
	Renderer:copy(TrySDL(Renderer.createTextureFromSurface, Renderer, TrySDL(Image.load, "./Fonts/8")), nil, Rect)
  elseif Char == "9" then
	Renderer:copy(TrySDL(Renderer.createTextureFromSurface, Renderer, TrySDL(Image.load, "./Fonts/9")), nil, Rect)
  elseif Char == " " then
	Renderer:copy(TrySDL(Renderer.createTextureFromSurface, Renderer, TrySDL(Image.load, "./Fonts/WhiteSpace")), nil, Rect)
  elseif Char == "-" then
	Renderer:copy(TrySDL(Renderer.createTextureFromSurface, Renderer, TrySDL(Image.load, "./Fonts/Dash")), nil, Rect)
  elseif Char == ":" then
	Renderer:copy(TrySDL(Renderer.createTextureFromSurface, Renderer, TrySDL(Image.load, "./Fonts/Colon")), nil, Rect)
  elseif Char == "/" then
	Renderer:copy(TrySDL(Renderer.createTextureFromSurface, Renderer, TrySDL(Image.load, "./Fonts/ForwardSlash")), nil, Rect)
  elseif Char == "." then
	Renderer:copy(TrySDL(Renderer.createTextureFromSurface, Renderer, TrySDL(Image.load, "./Fonts/Period")), nil, Rect)
  else
	return
  end

end

return Text
